<template>
  <BaseMap
    ref="map"
    :style="mapStyle"
    :center="photoLatLng"
    :zoom="16"
    :overlays-config="mapOverlays"
    @map-ready="onMapReady"
  />
</template>

<script>
import * as L from 'leaflet'

import BaseMap from 'src/components/BaseMap'
import { getMediaSrc } from 'src/utils/urls'
import { getDefaultOverlayLayersConfig, getHoldingCampaignPlotsLayer } from 'src/services/map/layers/layer-configs'

export default {
  name: 'PhotoMap',
  components: {
    BaseMap
  },
  props: {
    mapStyle: {
      type: String,
      default: ''
    },
    photo: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      photoIcon: null,
      photoMarker: null
    }
  },
  computed: {
    photoLatLng () {
      if (this.photo?.location) {
        return [this.photo.location.coordinates[1], this.photo.location.coordinates[0]]
      } else {
        return null
      }
    },
    plotId () {
      return this.photo?.plot?.id
    },
    mapOverlays () {
      const overlays = getDefaultOverlayLayersConfig()

      // add the holding campaign plots
      const holdingCampaignPlotsLayer = {
        ...getHoldingCampaignPlotsLayer(true, { holdingCampaignId: this.$store.state.fastplatform.holdingCampaign.id }),
        currentPlotId: this.plotId,
        hideCurrentPlot: this.plotId != null
      }
      overlays.push(holdingCampaignPlotsLayer)

      // add the selected plot in a separate plot to make sure it is not drawn over by other plots
      if (this.plotId != null) {
        const plotLayer = {
          ...getHoldingCampaignPlotsLayer(true, { plotId: this.plotId }),
          title: this.$pgettext('Plot of agricultural land', 'Selected plot'),
          currentPlotId: this.plotId,
          highlighted: true
        }
        overlays.push(plotLayer)
      }

      return overlays
    }
  },
  methods: {
    async addPhotoMarker (photo, map) {
      let src
      if (photo.isLocal) {
        src = photo.photo.startsWith('data:image/png;base64,')
          ? photo.photo
          : 'data:image/png;base64,' + photo.photo
      } else if (photo.photo) {
        src = await getMediaSrc(photo.photo)
      } else {
        src = require('../../../../components/grey-square.svg')
      }

      let html
      if (photo.heading != null) {
        const rotation = Math.round(45 + photo.heading)
        html = `<div><div class="arrow" style="transform: rotate(${rotation}deg);"></div><img src="${src}"/></div>`
      } else {
        html = `<div><img src="${src}"/></div>`
      }

      const icon = new L.DivIcon({
        className: 'photo-marker-one',
        html
      })

      const marker = L.marker(this.photoLatLng, { icon })
      marker.addTo(map)
    },
    removePhotoMarker () {
      if (this.photoMarker) {
        this.photoMarker.remove()
      }
    },
    async onMapReady (map) {
      await this.addPhotoMarker(this.photo, map)
    }
  },
  beforeUnmount () {
    this.removePhotoMarker()
  }
}
</script>

<style>

.photo-marker-one > div {
  transform: translate(-30px, -30px);
}

.photo-marker-one > div > img {
  position: absolute;
  top: 0;
  left: 0;
  width: 60px;
  height: 60px;
  border-radius: 100%;
  object-fit: cover;
  border: 2px solid #008FC4;
}

.photo-marker-one > div > div.arrow {
  position: absolute;
  top: 0;
  left: 0;
  width: 60px;
  height: 60px;
  border-top-right-radius: 100%;
  border-bottom-right-radius: 100%;
  border-bottom-left-radius: 100%;
  background-color: #008FC4;
  filter: drop-shadow(-2px -2px 4px #999999);
}

</style>
